/* Notification.c generated by valac 0.34.4, the Vala compiler
 * generated from Notification.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>
#include <libwnck/libwnck.h>
#include <granite.h>


#define TYPE_NOTIFICATION (notification_get_type ())
#define NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION, Notification))
#define NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION, NotificationClass))
#define IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION))
#define IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION))
#define NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION, NotificationClass))

typedef struct _Notification Notification;
typedef struct _NotificationClass NotificationClass;
typedef struct _NotificationPrivate NotificationPrivate;

#define NOTIFICATION_TYPE_COLUMN (notification_column_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_NOTIFICATION_MONITOR (notification_monitor_get_type ())
#define NOTIFICATION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MONITOR, NotificationMonitor))
#define NOTIFICATION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MONITOR, NotificationMonitorClass))
#define IS_NOTIFICATION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MONITOR))
#define IS_NOTIFICATION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MONITOR))
#define NOTIFICATION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MONITOR, NotificationMonitorClass))

typedef struct _NotificationMonitor NotificationMonitor;
typedef struct _NotificationMonitorClass NotificationMonitorClass;
typedef struct _NotificationMonitorPrivate NotificationMonitorPrivate;

#define TYPE_INOTIFICATIONS (inotifications_get_type ())
#define INOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INOTIFICATIONS, INotifications))
#define IS_INOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INOTIFICATIONS))
#define INOTIFICATIONS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INOTIFICATIONS, INotificationsIface))

typedef struct _INotifications INotifications;
typedef struct _INotificationsIface INotificationsIface;

#define TYPE_INOTIFICATIONS_PROXY (inotifications_proxy_get_type ())

#define TYPE_ID_BUS (id_bus_get_type ())
#define ID_BUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_BUS, IDBus))
#define IS_ID_BUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_BUS))
#define ID_BUS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ID_BUS, IDBusIface))

typedef struct _IDBus IDBus;
typedef struct _IDBusIface IDBusIface;

#define TYPE_ID_BUS_PROXY (id_bus_proxy_get_type ())
typedef struct _Block8Data Block8Data;

#define TYPE_NOTIFY_SETTINGS (notify_settings_get_type ())
#define NOTIFY_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFY_SETTINGS, NotifySettings))
#define NOTIFY_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFY_SETTINGS, NotifySettingsClass))
#define IS_NOTIFY_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFY_SETTINGS))
#define IS_NOTIFY_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFY_SETTINGS))
#define NOTIFY_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFY_SETTINGS, NotifySettingsClass))

typedef struct _NotifySettings NotifySettings;
typedef struct _NotifySettingsClass NotifySettingsClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _Notification {
	GObject parent_instance;
	NotificationPrivate * priv;
	gboolean data_session;
	gchar* app_name;
	gchar* summary;
	gchar* message_body;
	gchar* app_icon;
	gchar* sender;
	gchar** actions;
	gint actions_length1;
	GVariant* hints;
	gint32 expire_timeout;
	guint32 replaces_id;
	guint32 id;
	guint32 pid;
	GDateTime* timestamp;
	gint64 unix_time;
	gchar* desktop_id;
	GAppInfo* app_info;
};

struct _NotificationClass {
	GObjectClass parent_class;
};

struct _NotificationPrivate {
	gboolean pid_acquired;
};

typedef enum  {
	NOTIFICATION_COLUMN_APP_NAME = 0,
	NOTIFICATION_COLUMN_REPLACES_ID,
	NOTIFICATION_COLUMN_APP_ICON,
	NOTIFICATION_COLUMN_SUMMARY,
	NOTIFICATION_COLUMN_BODY,
	NOTIFICATION_COLUMN_ACTIONS,
	NOTIFICATION_COLUMN_HINTS,
	NOTIFICATION_COLUMN_EXPIRE_TIMEOUT,
	NOTIFICATION_COLUMN_COUNT
} NotificationColumn;

struct _INotificationsIface {
	GTypeInterface parent_iface;
	guint32 (*notify) (INotifications* self, const gchar* app_name, guint32 replaces_id, const gchar* app_icon, const gchar* summary, const gchar* body, gchar** actions, int actions_length1, GHashTable* hints, gint32 expire_timeout, GError** error);
};

struct _IDBusIface {
	GTypeInterface parent_iface;
	gboolean (*name_has_owner) (IDBus* self, const gchar* name, GError** error);
	guint32 (*get_connection_unix_process_id) (IDBus* self, const gchar* name, GError** error);
};

struct _NotificationMonitor {
	GObject parent_instance;
	NotificationMonitorPrivate * priv;
	INotifications* notifications_iface;
	IDBus* dbus_iface;
};

struct _NotificationMonitorClass {
	GObjectClass parent_class;
};

struct _Block8Data {
	int _ref_count_;
	Notification* self;
	WnckWindow* window;
};


static gpointer notification_parent_class = NULL;

GType notification_get_type (void) G_GNUC_CONST;
#define NOTIFICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTIFICATION, NotificationPrivate))
enum  {
	NOTIFICATION_DUMMY_PROPERTY
};
static GType notification_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define NOTIFICATION_DESKTOP_ID_EXT ".desktop"
#define NOTIFICATION_DEFAULT_ACTION "default"
#define NOTIFICATION_X_CANONICAL_PRIVATE_KEY "x-canonical-private-synchronous"
#define NOTIFICATION_DESKTOP_ENTRY_KEY "desktop-entry"
#define NOTIFICATION_FALLBACK_DESKTOP_ID "gala-other" NOTIFICATION_DESKTOP_ID_EXT
Notification* notification_new_from_message (GDBusMessage* message, guint32 _id);
Notification* notification_construct_from_message (GType object_type, GDBusMessage* message, guint32 _id);
static gchar* notification_get_string (Notification* self, GVariant* tuple, gint column);
static gint32 notification_get_int32 (Notification* self, GVariant* tuple, gint column);
static guint32 notification_get_uint32 (Notification* self, GVariant* tuple, gint column);
GAppInfo* utils_get_appinfo_from_app_name (const gchar* app_name);
static gchar* notification_lookup_string (Notification* self, GVariant* tuple, const gchar* key);
static void notification_setup_pid (Notification* self);
static gboolean notification_source_func (Notification* self);
static gboolean _notification_source_func_gsource_func (gpointer self);
Notification* notification_new_from_data (guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender);
Notification* notification_construct_from_data (GType object_type, guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender);
static gchar** _vala_array_dup2 (gchar** self, int length);
gboolean notification_get_is_valid (Notification* self);
gboolean notification_run_default_action (Notification* self);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
GType notification_monitor_get_type (void) G_GNUC_CONST;
NotificationMonitor* notification_monitor_get_instance (void);
GType inotifications_proxy_get_type (void) G_GNUC_CONST;
guint inotifications_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType inotifications_get_type (void) G_GNUC_CONST;
GType id_bus_proxy_get_type (void) G_GNUC_CONST;
guint id_bus_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType id_bus_get_type (void) G_GNUC_CONST;
WnckWindow* notification_get_app_window (Notification* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda6_ (Block8Data* _data8_, WnckWindow* _window);
static void ____lambda6__gfunc (gconstpointer data, gpointer self);
static gboolean notification_try_get_pid (Notification* self);
GType notify_settings_get_type (void) G_GNUC_CONST;
NotifySettings* notify_settings_get_instance (void);
#define NOTIFY_SETTINGS_DO_NOT_DISTURB_KEY "do-not-disturb"
static void __lambda4_ (Notification* self);
static void ___lambda4__granite_services_settings_changed (GraniteServicesSettings* _sender, gpointer self);
gboolean notify_settings_get_do_not_disturb (NotifySettings* self);
gboolean id_bus_name_has_owner (IDBus* self, const gchar* name, GError** error);
guint32 id_bus_get_connection_unix_process_id (IDBus* self, const gchar* name, GError** error);
Notification* notification_new (void);
Notification* notification_construct (GType object_type);
static void g_cclosure_user_marshal_BOOLEAN__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void notification_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static GType notification_column_get_type (void) {
	static volatile gsize notification_column_type_id__volatile = 0;
	if (g_once_init_enter (&notification_column_type_id__volatile)) {
		static const GEnumValue values[] = {{NOTIFICATION_COLUMN_APP_NAME, "NOTIFICATION_COLUMN_APP_NAME", "app-name"}, {NOTIFICATION_COLUMN_REPLACES_ID, "NOTIFICATION_COLUMN_REPLACES_ID", "replaces-id"}, {NOTIFICATION_COLUMN_APP_ICON, "NOTIFICATION_COLUMN_APP_ICON", "app-icon"}, {NOTIFICATION_COLUMN_SUMMARY, "NOTIFICATION_COLUMN_SUMMARY", "summary"}, {NOTIFICATION_COLUMN_BODY, "NOTIFICATION_COLUMN_BODY", "body"}, {NOTIFICATION_COLUMN_ACTIONS, "NOTIFICATION_COLUMN_ACTIONS", "actions"}, {NOTIFICATION_COLUMN_HINTS, "NOTIFICATION_COLUMN_HINTS", "hints"}, {NOTIFICATION_COLUMN_EXPIRE_TIMEOUT, "NOTIFICATION_COLUMN_EXPIRE_TIMEOUT", "expire-timeout"}, {NOTIFICATION_COLUMN_COUNT, "NOTIFICATION_COLUMN_COUNT", "count"}, {0, NULL, NULL}};
		GType notification_column_type_id;
		notification_column_type_id = g_enum_register_static ("NotificationColumn", values);
		g_once_init_leave (&notification_column_type_id__volatile, notification_column_type_id);
	}
	return notification_column_type_id__volatile;
}


static gpointer _g_variant_ref0 (gpointer self) {
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return self ? g_variant_ref (self) : NULL;
#line 237 "Notification.c"
}


static gboolean _notification_source_func_gsource_func (gpointer self) {
	gboolean result;
	result = notification_source_func ((Notification*) self);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 246 "Notification.c"
}


Notification* notification_construct_from_message (GType object_type, GDBusMessage* message, guint32 _id) {
	Notification * self = NULL;
	GVariant* body = NULL;
	GDBusMessage* _tmp0_ = NULL;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GVariant* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GVariant* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	GVariant* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	GVariant* _tmp11_ = NULL;
	GVariant* _tmp12_ = NULL;
	GVariant* _tmp13_ = NULL;
	gint32 _tmp14_ = 0;
	GVariant* _tmp15_ = NULL;
	guint32 _tmp16_ = 0U;
	guint32 _tmp17_ = 0U;
	GDBusMessage* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	GVariant* _tmp21_ = NULL;
	GVariant* _tmp22_ = NULL;
	GVariant* _tmp23_ = NULL;
	size_t _tmp24_;
	gchar** _tmp25_ = NULL;
	GDateTime* _tmp26_ = NULL;
	GDateTime* _tmp27_ = NULL;
	gint64 _tmp28_ = 0LL;
	const gchar* _tmp29_ = NULL;
	GAppInfo* _tmp30_ = NULL;
	GAppInfo* _tmp31_ = NULL;
	gboolean _tmp37_ = FALSE;
	const gchar* _tmp38_ = NULL;
	GAppInfo* _tmp45_ = NULL;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self = (Notification*) g_object_new (object_type, NULL);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = message;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = g_dbus_message_get_body (_tmp0_);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = _g_variant_ref0 (_tmp1_);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	body = _tmp2_;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->data_session = FALSE;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = body;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp4_ = notification_get_string (self, _tmp3_, (gint) NOTIFICATION_COLUMN_APP_NAME);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->app_name);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->app_name = _tmp4_;
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp5_ = body;
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp6_ = notification_get_string (self, _tmp5_, (gint) NOTIFICATION_COLUMN_APP_ICON);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->app_icon);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->app_icon = _tmp6_;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp7_ = body;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp8_ = notification_get_string (self, _tmp7_, (gint) NOTIFICATION_COLUMN_SUMMARY);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->summary);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->summary = _tmp8_;
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp9_ = body;
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp10_ = notification_get_string (self, _tmp9_, (gint) NOTIFICATION_COLUMN_BODY);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->message_body);
#line 68 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->message_body = _tmp10_;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp11_ = body;
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) NOTIFICATION_COLUMN_HINTS);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (self->hints);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->hints = _tmp12_;
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp13_ = body;
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp14_ = notification_get_int32 (self, _tmp13_, (gint) NOTIFICATION_COLUMN_EXPIRE_TIMEOUT);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->expire_timeout = _tmp14_;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp15_ = body;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp16_ = notification_get_uint32 (self, _tmp15_, (gint) NOTIFICATION_COLUMN_REPLACES_ID);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->replaces_id = _tmp16_;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp17_ = _id;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->id = _tmp17_;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp18_ = message;
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp19_ = g_dbus_message_get_sender (_tmp18_);
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->sender);
#line 73 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->sender = _tmp20_;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp21_ = body;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp22_ = g_variant_get_child_value (_tmp21_, (gsize) NOTIFICATION_COLUMN_ACTIONS);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp23_ = _tmp22_;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp25_ = g_variant_dup_strv (_tmp23_, &_tmp24_);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->actions = (_vala_array_free (self->actions, self->actions_length1, (GDestroyNotify) g_free), NULL);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->actions = _tmp25_;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->actions_length1 = _tmp24_;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (_tmp23_);
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp26_ = g_date_time_new_now_local ();
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_date_time_unref0 (self->timestamp);
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->timestamp = _tmp26_;
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp27_ = self->timestamp;
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp28_ = g_date_time_to_unix (_tmp27_);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->unix_time = _tmp28_;
#line 79 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp29_ = self->app_name;
#line 79 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp30_ = utils_get_appinfo_from_app_name (_tmp29_);
#line 79 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_object_unref0 (self->app_info);
#line 79 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->app_info = _tmp30_;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp31_ = self->app_info;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp31_ != NULL) {
#line 408 "Notification.c"
		GAppInfo* _tmp32_ = NULL;
		const gchar* _tmp33_ = NULL;
		gchar* _tmp34_ = NULL;
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp32_ = self->app_info;
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp33_ = g_app_info_get_id (_tmp32_);
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp34_ = g_strdup (_tmp33_);
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_free0 (self->desktop_id);
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		self->desktop_id = _tmp34_;
#line 422 "Notification.c"
	} else {
		GVariant* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp35_ = self->hints;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp36_ = notification_lookup_string (self, _tmp35_, NOTIFICATION_DESKTOP_ENTRY_KEY);
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_free0 (self->desktop_id);
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		self->desktop_id = _tmp36_;
#line 434 "Notification.c"
	}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp38_ = self->desktop_id;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (g_strcmp0 (_tmp38_, "") != 0) {
#line 440 "Notification.c"
		const gchar* _tmp39_ = NULL;
		gboolean _tmp40_ = FALSE;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp39_ = self->desktop_id;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp40_ = g_str_has_suffix (_tmp39_, NOTIFICATION_DESKTOP_ID_EXT);
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp37_ = !_tmp40_;
#line 449 "Notification.c"
	} else {
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp37_ = FALSE;
#line 453 "Notification.c"
	}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp37_) {
#line 457 "Notification.c"
		const gchar* _tmp41_ = NULL;
		gchar* _tmp42_ = NULL;
		const gchar* _tmp43_ = NULL;
		GDesktopAppInfo* _tmp44_ = NULL;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp41_ = self->desktop_id;
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp42_ = g_strconcat (_tmp41_, NOTIFICATION_DESKTOP_ID_EXT, NULL);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_free0 (self->desktop_id);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		self->desktop_id = _tmp42_;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp43_ = self->desktop_id;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp44_ = g_desktop_app_info_new (_tmp43_);
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (self->app_info);
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		self->app_info = (GAppInfo*) _tmp44_;
#line 478 "Notification.c"
	}
#line 92 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp45_ = self->app_info;
#line 92 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp45_ == NULL) {
#line 484 "Notification.c"
		gchar* _tmp46_ = NULL;
		const gchar* _tmp47_ = NULL;
		GDesktopAppInfo* _tmp48_ = NULL;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp46_ = g_strdup (NOTIFICATION_FALLBACK_DESKTOP_ID);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_free0 (self->desktop_id);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		self->desktop_id = _tmp46_;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp47_ = self->desktop_id;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp48_ = g_desktop_app_info_new (_tmp47_);
#line 94 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (self->app_info);
#line 94 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		self->app_info = (GAppInfo*) _tmp48_;
#line 502 "Notification.c"
	}
#line 97 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	notification_setup_pid (self);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 60, _notification_source_func_gsource_func, g_object_ref (self), g_object_unref);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (body);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return self;
#line 512 "Notification.c"
}


Notification* notification_new_from_message (GDBusMessage* message, guint32 _id) {
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return notification_construct_from_message (TYPE_NOTIFICATION, message, _id);
#line 519 "Notification.c"
}


static gchar** _vala_array_dup2 (gchar** self, int length) {
	gchar** result;
	int i;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = g_new0 (gchar*, length + 1);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	for (i = 0; i < length; i++) {
#line 530 "Notification.c"
		gchar* _tmp0_ = NULL;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp0_ = g_strdup (self[i]);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		result[i] = _tmp0_;
#line 536 "Notification.c"
	}
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 540 "Notification.c"
}


Notification* notification_construct_from_data (GType object_type, guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender) {
	Notification * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	guint32 _tmp8_ = 0U;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar** _tmp11_ = NULL;
	gint _tmp11__length1 = 0;
	gchar** _tmp12_ = NULL;
	gint _tmp12__length1 = 0;
	gint64 _tmp13_ = 0LL;
	gint64 _tmp14_ = 0LL;
	GDateTime* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	GDesktopAppInfo* _tmp19_ = NULL;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (_app_name != NULL, NULL);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (_app_icon != NULL, NULL);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (_summary != NULL, NULL);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (_message_body != NULL, NULL);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (_desktop_id != NULL, NULL);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (_sender != NULL, NULL);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self = (Notification*) g_object_new (object_type, NULL);
#line 105 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->data_session = TRUE;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = _app_name;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->app_name);
#line 107 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->app_name = _tmp1_;
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = _app_icon;
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->app_icon);
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->app_icon = _tmp3_;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp4_ = _summary;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->summary);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->summary = _tmp5_;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp6_ = _message_body;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->message_body);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->message_body = _tmp7_;
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->expire_timeout = (gint32) -1;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->replaces_id = (guint32) 0;
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp8_ = _id;
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->id = _tmp8_;
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp9_ = _sender;
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->sender);
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->sender = _tmp10_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp11_ = _actions;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp11__length1 = _actions_length1;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup2 (_tmp11_, _tmp11__length1) : ((gpointer) _tmp11_);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp12__length1 = _tmp11__length1;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->actions = (_vala_array_free (self->actions, self->actions_length1, (GDestroyNotify) g_free), NULL);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->actions = _tmp12_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->actions_length1 = _tmp12__length1;
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp13_ = _unix_time;
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->unix_time = _tmp13_;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp14_ = self->unix_time;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp15_ = g_date_time_new_from_unix_local (_tmp14_);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_date_time_unref0 (self->timestamp);
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->timestamp = _tmp15_;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp16_ = _desktop_id;
#line 120 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 120 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->desktop_id);
#line 120 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->desktop_id = _tmp17_;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp18_ = self->desktop_id;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp19_ = g_desktop_app_info_new (_tmp18_);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_object_unref0 (self->app_info);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->app_info = (GAppInfo*) _tmp19_;
#line 123 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	notification_setup_pid (self);
#line 125 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 60, _notification_source_func_gsource_func, g_object_ref (self), g_object_unref);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return self;
#line 680 "Notification.c"
}


Notification* notification_new_from_data (guint32 _id, const gchar* _app_name, const gchar* _app_icon, const gchar* _summary, const gchar* _message_body, gchar** _actions, int _actions_length1, const gchar* _desktop_id, gint64 _unix_time, const gchar* _sender) {
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return notification_construct_from_data (TYPE_NOTIFICATION, _id, _app_name, _app_icon, _summary, _message_body, _actions, _actions_length1, _desktop_id, _unix_time, _sender);
#line 687 "Notification.c"
}


gboolean notification_get_is_valid (Notification* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GAppInfo* _tmp1_ = NULL;
#line 128 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = self->app_info;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp1_ != NULL) {
#line 701 "Notification.c"
		GVariant* _tmp2_ = NULL;
		GVariant* _tmp3_ = NULL;
		GVariant* _tmp4_ = NULL;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp2_ = self->hints;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp3_ = g_variant_lookup_value (_tmp2_, NOTIFICATION_X_CANONICAL_PRIVATE_KEY, NULL);
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp4_ = _tmp3_;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_variant_unref0 (_tmp4_);
#line 715 "Notification.c"
	} else {
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp0_ = FALSE;
#line 719 "Notification.c"
	}
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = _tmp0_;
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 725 "Notification.c"
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	for (i = 0; i < stack_length; i++) {
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			return TRUE;
#line 737 "Notification.c"
		}
	}
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return FALSE;
#line 742 "Notification.c"
}


gboolean notification_run_default_action (Notification* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
#line 132 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = self->actions;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1__length1 = self->actions_length1;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_vala_string_array_contains (_tmp1_, _tmp1__length1, NOTIFICATION_DEFAULT_ACTION)) {
#line 759 "Notification.c"
		NotificationMonitor* _tmp2_ = NULL;
		NotificationMonitor* _tmp3_ = NULL;
		INotifications* _tmp4_ = NULL;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp2_ = notification_monitor_get_instance ();
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp3_ = _tmp2_;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp4_ = _tmp3_->notifications_iface;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (_tmp3_);
#line 773 "Notification.c"
	} else {
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp0_ = FALSE;
#line 777 "Notification.c"
	}
#line 133 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp0_) {
#line 781 "Notification.c"
		NotificationMonitor* _tmp5_ = NULL;
		NotificationMonitor* _tmp6_ = NULL;
		INotifications* _tmp7_ = NULL;
		guint32 _tmp8_ = 0U;
#line 134 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp5_ = notification_monitor_get_instance ();
#line 134 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp6_ = _tmp5_;
#line 134 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp7_ = _tmp6_->notifications_iface;
#line 134 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp8_ = self->id;
#line 134 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		g_signal_emit_by_name (_tmp7_, "action-invoked", NOTIFICATION_DEFAULT_ACTION, _tmp8_);
#line 134 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (_tmp6_);
#line 135 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		result = TRUE;
#line 135 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		return result;
#line 802 "Notification.c"
	}
#line 138 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = FALSE;
#line 138 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 808 "Notification.c"
}


static Block8Data* block8_data_ref (Block8Data* _data8_) {
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return _data8_;
#line 817 "Notification.c"
}


static void block8_data_unref (void * _userdata_) {
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 826 "Notification.c"
		Notification* self;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		self = _data8_->self;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (_data8_->window);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (self);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		g_slice_free (Block8Data, _data8_);
#line 836 "Notification.c"
	}
}


static gpointer _g_object_ref0 (gpointer self) {
#line 146 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 844 "Notification.c"
}


static void ___lambda6_ (Block8Data* _data8_, WnckWindow* _window) {
	Notification* self;
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	guint32 _tmp3_ = 0U;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self = _data8_->self;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_if_fail (_window != NULL);
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = _window;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = wnck_window_get_pid (_tmp1_);
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = self->pid;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (((guint32) _tmp2_) == _tmp3_) {
#line 866 "Notification.c"
		WnckWindow* _tmp4_ = NULL;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp4_ = _data8_->window;
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 872 "Notification.c"
	} else {
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp0_ = FALSE;
#line 876 "Notification.c"
	}
#line 145 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp0_) {
#line 880 "Notification.c"
		WnckWindow* _tmp5_ = NULL;
		WnckWindow* _tmp6_ = NULL;
#line 146 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp5_ = _window;
#line 146 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 146 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (_data8_->window);
#line 146 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_data8_->window = _tmp6_;
#line 147 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		return;
#line 893 "Notification.c"
	}
}


static void ____lambda6__gfunc (gconstpointer data, gpointer self) {
#line 144 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	___lambda6_ (self, (WnckWindow*) data);
#line 901 "Notification.c"
}


WnckWindow* notification_get_app_window (Notification* self) {
	WnckWindow* result = NULL;
	Block8Data* _data8_;
	gboolean _tmp0_ = FALSE;
	WnckWindow* _tmp3_ = NULL;
	WnckWindow* _tmp4_ = NULL;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_data8_->_ref_count_ = 1;
#line 141 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_data8_->self = g_object_ref (self);
#line 142 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_data8_->window = NULL;
#line 143 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = self->priv->pid_acquired;
#line 143 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp0_) {
#line 925 "Notification.c"
		WnckScreen* _tmp1_ = NULL;
		GList* _tmp2_ = NULL;
#line 144 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp1_ = wnck_screen_get_default ();
#line 144 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp2_ = wnck_screen_get_windows (_tmp1_);
#line 144 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		g_list_foreach (_tmp2_, ____lambda6__gfunc, _data8_);
#line 934 "Notification.c"
	}
#line 152 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = _data8_->window;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = _tmp4_;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	block8_data_unref (_data8_);
#line 152 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_data8_ = NULL;
#line 152 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 948 "Notification.c"
}


static void __lambda4_ (Notification* self) {
	gboolean _tmp0_ = FALSE;
#line 158 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = self->priv->pid_acquired;
#line 158 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (!_tmp0_) {
#line 159 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		notification_try_get_pid (self);
#line 960 "Notification.c"
	}
}


static void ___lambda4__granite_services_settings_changed (GraniteServicesSettings* _sender, gpointer self) {
#line 157 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	__lambda4_ ((Notification*) self);
#line 968 "Notification.c"
}


static void notification_setup_pid (Notification* self) {
	gboolean _tmp0_ = FALSE;
	NotifySettings* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 155 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_if_fail (self != NULL);
#line 156 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = notification_try_get_pid (self);
#line 156 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->priv->pid_acquired = _tmp0_;
#line 157 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = notify_settings_get_instance ();
#line 157 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = g_strconcat ("changed::", NOTIFY_SETTINGS_DO_NOT_DISTURB_KEY, NULL);
#line 157 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_signal_connect_object ((GraniteServicesSettings*) _tmp1_, _tmp2_, (GCallback) ___lambda4__granite_services_settings_changed, self, 0);
#line 157 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (_tmp2_);
#line 990 "Notification.c"
}


static gboolean notification_try_get_pid (Notification* self) {
	gboolean result = FALSE;
	NotifySettings* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 164 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 165 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = notify_settings_get_instance ();
#line 165 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = notify_settings_get_do_not_disturb (_tmp0_);
#line 165 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = _tmp1_;
#line 165 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp2_) {
#line 166 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		result = FALSE;
#line 166 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		return result;
#line 1014 "Notification.c"
	}
	{
		IDBus* dbus_iface = NULL;
		IDBus* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		IDBus* _tmp5_ = NULL;
#line 170 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp3_ = g_initable_new (TYPE_ID_BUS_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "org.freedesktop.DBus", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/", "g-interface-name", "org.freedesktop.DBus", "g-interface-info", g_type_get_qdata (TYPE_ID_BUS, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 170 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		dbus_iface = (IDBus*) _tmp3_;
#line 170 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1027 "Notification.c"
			goto __catch10_g_error;
		}
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp5_ = dbus_iface;
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		if (_tmp5_ != NULL) {
#line 1034 "Notification.c"
			gboolean _tmp6_ = FALSE;
			IDBus* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp7_ = dbus_iface;
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp8_ = self->sender;
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp9_ = id_bus_name_has_owner (_tmp7_, _tmp8_, &_inner_error_);
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp6_ = _tmp9_;
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
				_g_object_unref0 (dbus_iface);
#line 1051 "Notification.c"
				goto __catch10_g_error;
			}
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp4_ = _tmp6_;
#line 1056 "Notification.c"
		} else {
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp4_ = FALSE;
#line 1060 "Notification.c"
		}
#line 171 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		if (_tmp4_) {
#line 1064 "Notification.c"
			guint32 _tmp10_ = 0U;
			IDBus* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			guint32 _tmp13_ = 0U;
#line 172 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp11_ = dbus_iface;
#line 172 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp12_ = self->sender;
#line 172 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp13_ = id_bus_get_connection_unix_process_id (_tmp11_, _tmp12_, &_inner_error_);
#line 172 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			_tmp10_ = _tmp13_;
#line 172 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 172 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
				_g_object_unref0 (dbus_iface);
#line 1081 "Notification.c"
				goto __catch10_g_error;
			}
#line 172 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
			self->pid = _tmp10_;
#line 1086 "Notification.c"
		}
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_object_unref0 (dbus_iface);
#line 1090 "Notification.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		e = _inner_error_;
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_inner_error_ = NULL;
#line 175 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp14_ = e;
#line 175 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp15_ = _tmp14_->message;
#line 175 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		g_warning ("Notification.vala:175: %s\n", _tmp15_);
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_error_free0 (e);
#line 1110 "Notification.c"
	}
	__finally10:
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		g_clear_error (&_inner_error_);
#line 169 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		return FALSE;
#line 1121 "Notification.c"
	}
#line 178 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = TRUE;
#line 178 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 1127 "Notification.c"
}


static gchar* notification_get_string (Notification* self, GVariant* tuple, gint column) {
	gchar* result = NULL;
	GVariant* child = NULL;
	GVariant* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GVariant* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 181 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 181 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, NULL);
#line 182 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = tuple;
#line 182 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = column;
#line 182 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = g_variant_get_child_value (_tmp0_, (gsize) _tmp1_);
#line 182 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	child = _tmp2_;
#line 183 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = g_variant_dup_string (child, NULL);
#line 183 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = _tmp3_;
#line 183 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (child);
#line 183 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 1158 "Notification.c"
}


static gint32 notification_get_int32 (Notification* self, GVariant* tuple, gint column) {
	gint32 result = 0;
	GVariant* child = NULL;
	GVariant* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GVariant* _tmp2_ = NULL;
	gint32 _tmp3_ = 0;
#line 186 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 186 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, 0);
#line 187 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = tuple;
#line 187 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = column;
#line 187 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = g_variant_get_child_value (_tmp0_, (gsize) _tmp1_);
#line 187 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	child = _tmp2_;
#line 188 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = g_variant_get_int32 (child);
#line 188 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = _tmp3_;
#line 188 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (child);
#line 188 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 1189 "Notification.c"
}


static guint32 notification_get_uint32 (Notification* self, GVariant* tuple, gint column) {
	guint32 result = 0U;
	GVariant* child = NULL;
	GVariant* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GVariant* _tmp2_ = NULL;
	guint32 _tmp3_ = 0U;
#line 191 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 191 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, 0U);
#line 192 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = tuple;
#line 192 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = column;
#line 192 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = g_variant_get_child_value (_tmp0_, (gsize) _tmp1_);
#line 192 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	child = _tmp2_;
#line 193 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = g_variant_get_uint32 (child);
#line 193 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = _tmp3_;
#line 193 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (child);
#line 193 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 1220 "Notification.c"
}


static gchar* notification_lookup_string (Notification* self, GVariant* tuple, const gchar* key) {
	gchar* result = NULL;
	GVariant* child = NULL;
	GVariant* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GVariant* _tmp4_ = NULL;
	GVariant* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
#line 196 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 196 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (tuple != NULL, NULL);
#line 196 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 197 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = tuple;
#line 197 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = key;
#line 197 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = g_variant_lookup_value (_tmp0_, _tmp1_, NULL);
#line 197 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	child = _tmp2_;
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp4_ = child;
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp4_ == NULL) {
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp3_ = TRUE;
#line 1254 "Notification.c"
	} else {
		GVariant* _tmp5_ = NULL;
		const GVariantType* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp5_ = child;
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp6_ = G_VARIANT_TYPE_STRING;
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp7_ = g_variant_is_of_type (_tmp5_, _tmp6_);
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp3_ = !_tmp7_;
#line 1267 "Notification.c"
	}
#line 199 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (_tmp3_) {
#line 1271 "Notification.c"
		gchar* _tmp8_ = NULL;
#line 200 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_tmp8_ = g_strdup ("");
#line 200 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		result = _tmp8_;
#line 200 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		_g_variant_unref0 (child);
#line 200 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		return result;
#line 1281 "Notification.c"
	}
#line 203 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp9_ = child;
#line 203 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp10_ = g_variant_dup_string (_tmp9_, NULL);
#line 203 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = _tmp10_;
#line 203 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (child);
#line 203 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 1293 "Notification.c"
}


static gboolean notification_source_func (Notification* self) {
	gboolean result = FALSE;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GDateTime* _tmp2_ = NULL;
	GTimeSpan _tmp3_ = 0LL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 206 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp0_ = self->timestamp;
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp2_ = _tmp1_;
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp3_ = g_date_time_difference (_tmp0_, _tmp2_);
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_signal_emit_by_name (self, "time-changed", _tmp3_, &_tmp4_);
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_tmp5_ = _tmp4_;
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_date_time_unref0 (_tmp2_);
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	result = _tmp5_;
#line 207 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return result;
#line 1325 "Notification.c"
}


Notification* notification_construct (GType object_type) {
	Notification * self = NULL;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self = (Notification*) g_object_new (object_type, NULL);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return self;
#line 1335 "Notification.c"
}


Notification* notification_new (void) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	return notification_construct (TYPE_NOTIFICATION);
#line 1342 "Notification.c"
}


static void g_cclosure_user_marshal_BOOLEAN__INT64 (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef gboolean (*GMarshalFunc_BOOLEAN__INT64) (gpointer data1, GTimeSpan arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_if_fail (return_value != NULL);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_return_if_fail (n_param_values == 2);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		data1 = closure->data;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		data2 = param_values->data[0].v_pointer;
#line 1364 "Notification.c"
	} else {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		data1 = param_values->data[0].v_pointer;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
		data2 = closure->data;
#line 1370 "Notification.c"
	}
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	callback = (GMarshalFunc_BOOLEAN__INT64) (marshal_data ? marshal_data : cc->callback);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	v_return = callback (data1, g_value_get_int64 (param_values + 1), data2);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_value_set_boolean (return_value, v_return);
#line 1378 "Notification.c"
}


static void notification_class_init (NotificationClass * klass) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	notification_parent_class = g_type_class_peek_parent (klass);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_type_class_add_private (klass, sizeof (NotificationPrivate));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	G_OBJECT_CLASS (klass)->finalize = notification_finalize;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	g_signal_new ("time_changed", TYPE_NOTIFICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__INT64, G_TYPE_BOOLEAN, 1, G_TYPE_INT64);
#line 1391 "Notification.c"
}


static void notification_instance_init (Notification * self) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->priv = NOTIFICATION_GET_PRIVATE (self);
#line 33 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->pid = (guint32) 0;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->app_info = NULL;
#line 1402 "Notification.c"
}


static void notification_finalize (GObject* obj) {
	Notification * self;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTIFICATION, Notification);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->app_name);
#line 24 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->summary);
#line 25 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->message_body);
#line 26 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->app_icon);
#line 27 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->sender);
#line 28 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	self->actions = (_vala_array_free (self->actions, self->actions_length1, (GDestroyNotify) g_free), NULL);
#line 29 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_variant_unref0 (self->hints);
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_date_time_unref0 (self->timestamp);
#line 37 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_free0 (self->desktop_id);
#line 38 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	_g_object_unref0 (self->app_info);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/Notification.vala"
	G_OBJECT_CLASS (notification_parent_class)->finalize (obj);
#line 1432 "Notification.c"
}


GType notification_get_type (void) {
	static volatile gsize notification_type_id__volatile = 0;
	if (g_once_init_enter (&notification_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Notification), 0, (GInstanceInitFunc) notification_instance_init, NULL };
		GType notification_type_id;
		notification_type_id = g_type_register_static (G_TYPE_OBJECT, "Notification", &g_define_type_info, 0);
		g_once_init_leave (&notification_type_id__volatile, notification_type_id);
	}
	return notification_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



