/* NotificationsMonitor.c generated by valac 0.34.4, the Vala compiler
 * generated from NotificationsMonitor.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Original code from:
 * http://bazaar.launchpad.net/~jconti/recent-notifications/gnome3/view/head:/src/recent-notifications.vala
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_NOTIFICATION_MONITOR (notification_monitor_get_type ())
#define NOTIFICATION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MONITOR, NotificationMonitor))
#define NOTIFICATION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MONITOR, NotificationMonitorClass))
#define IS_NOTIFICATION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MONITOR))
#define IS_NOTIFICATION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MONITOR))
#define NOTIFICATION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MONITOR, NotificationMonitorClass))

typedef struct _NotificationMonitor NotificationMonitor;
typedef struct _NotificationMonitorClass NotificationMonitorClass;
typedef struct _NotificationMonitorPrivate NotificationMonitorPrivate;

#define TYPE_INOTIFICATIONS (inotifications_get_type ())
#define INOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INOTIFICATIONS, INotifications))
#define IS_INOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INOTIFICATIONS))
#define INOTIFICATIONS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INOTIFICATIONS, INotificationsIface))

typedef struct _INotifications INotifications;
typedef struct _INotificationsIface INotificationsIface;

#define TYPE_INOTIFICATIONS_PROXY (inotifications_proxy_get_type ())

#define TYPE_ID_BUS (id_bus_get_type ())
#define ID_BUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_BUS, IDBus))
#define IS_ID_BUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_BUS))
#define ID_BUS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ID_BUS, IDBusIface))

typedef struct _IDBus IDBus;
typedef struct _IDBusIface IDBusIface;

#define TYPE_ID_BUS_PROXY (id_bus_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _INotificationsIface {
	GTypeInterface parent_iface;
	guint32 (*notify) (INotifications* self, const gchar* app_name, guint32 replaces_id, const gchar* app_icon, const gchar* summary, const gchar* body, gchar** actions, int actions_length1, GHashTable* hints, gint32 expire_timeout, GError** error);
};

struct _IDBusIface {
	GTypeInterface parent_iface;
	gboolean (*name_has_owner) (IDBus* self, const gchar* name, GError** error);
	guint32 (*get_connection_unix_process_id) (IDBus* self, const gchar* name, GError** error);
};

struct _NotificationMonitor {
	GObject parent_instance;
	NotificationMonitorPrivate * priv;
	INotifications* notifications_iface;
	IDBus* dbus_iface;
};

struct _NotificationMonitorClass {
	GObjectClass parent_class;
};

struct _NotificationMonitorPrivate {
	GDBusConnection* connection;
	guint32 id_counter;
};

struct _Block6Data {
	int _ref_count_;
	NotificationMonitor* self;
	GDBusMessage* message;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	guint32 current_id;
};


static gpointer notification_monitor_parent_class = NULL;
static NotificationMonitor* notification_monitor_instance;
static NotificationMonitor* notification_monitor_instance = NULL;

GType notification_monitor_get_type (void) G_GNUC_CONST;
GType inotifications_proxy_get_type (void) G_GNUC_CONST;
guint inotifications_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType inotifications_get_type (void) G_GNUC_CONST;
GType id_bus_proxy_get_type (void) G_GNUC_CONST;
guint id_bus_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType id_bus_get_type (void) G_GNUC_CONST;
#define NOTIFICATION_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTIFICATION_MONITOR, NotificationMonitorPrivate))
enum  {
	NOTIFICATION_MONITOR_DUMMY_PROPERTY
};
#define NOTIFICATION_MONITOR_NOTIFY_IFACE "org.freedesktop.Notifications"
#define NOTIFICATION_MONITOR_NOTIFY_PATH "/org/freedesktop/Notifications"
#define NOTIFICATION_MONITOR_MATCH_STRING "eavesdrop='true',type='method_call',interface='org.freedesktop.Notific" \
"ations',member='Notify'"
#define NOTIFICATION_MONITOR_REASON_DISMISSED ((guint32) 2)
NotificationMonitor* notification_monitor_get_instance (void);
static NotificationMonitor* notification_monitor_new (void);
static NotificationMonitor* notification_monitor_construct (GType object_type);
static void notification_monitor_add_filter (NotificationMonitor* self);
static guint32 notification_monitor_get_current_notification_id (NotificationMonitor* self);
static GDBusMessage* notification_monitor_message_filter (NotificationMonitor* self, GDBusConnection* con, GDBusMessage* message, gboolean incoming);
static GDBusMessage* _notification_monitor_message_filter_gd_bus_message_filter_function (GDBusConnection* connection, GDBusMessage* message, gboolean incoming, gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean ____lambda5_ (Block7Data* _data7_);
static gboolean _____lambda5__gsource_func (gpointer self);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
guint32 inotifications_notify (INotifications* self, const gchar* app_name, guint32 replaces_id, const gchar* app_icon, const gchar* summary, const gchar* body, gchar** actions, int actions_length1, GHashTable* hints, gint32 expire_timeout, GError** error);
static void g_cclosure_user_marshal_VOID__OBJECT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void notification_monitor_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static gpointer _g_object_ref0 (gpointer self) {
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "NotificationsMonitor.c"
}


NotificationMonitor* notification_monitor_get_instance (void) {
	NotificationMonitor* result = NULL;
	NotificationMonitor* _tmp0_ = NULL;
	NotificationMonitor* _tmp2_ = NULL;
	NotificationMonitor* _tmp3_ = NULL;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp0_ = notification_monitor_instance;
#line 39 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (_tmp0_ == NULL) {
#line 167 "NotificationsMonitor.c"
		NotificationMonitor* _tmp1_ = NULL;
#line 40 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp1_ = notification_monitor_new ();
#line 40 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (notification_monitor_instance);
#line 40 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		notification_monitor_instance = _tmp1_;
#line 175 "NotificationsMonitor.c"
	}
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp2_ = notification_monitor_instance;
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	result = _tmp3_;
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return result;
#line 185 "NotificationsMonitor.c"
}


static NotificationMonitor* notification_monitor_construct (GType object_type) {
	NotificationMonitor * self = NULL;
	GError * _inner_error_ = NULL;
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self = (NotificationMonitor*) g_object_new (object_type, NULL);
#line 194 "NotificationsMonitor.c"
	{
		GDBusConnection* _tmp0_ = NULL;
		GDBusConnection* _tmp1_ = NULL;
		GDBusConnection* _tmp2_ = NULL;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp1_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error_);
#line 48 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp0_ = _tmp1_;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 205 "NotificationsMonitor.c"
			goto __catch6_g_error;
		}
#line 48 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp2_ = _tmp0_;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp0_ = NULL;
#line 48 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (self->priv->connection);
#line 48 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		self->priv->connection = _tmp2_;
#line 49 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		notification_monitor_add_filter (self);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (_tmp0_);
#line 220 "NotificationsMonitor.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_ = NULL;
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		e = _inner_error_;
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp3_ = e->message;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_error ("NotificationsMonitor.vala:51: %s\n", _tmp3_);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_error_free0 (e);
#line 237 "NotificationsMonitor.c"
	}
	__finally6:
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_clear_error (&_inner_error_);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		return NULL;
#line 248 "NotificationsMonitor.c"
	}
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return self;
#line 252 "NotificationsMonitor.c"
}


static NotificationMonitor* notification_monitor_new (void) {
#line 46 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return notification_monitor_construct (TYPE_NOTIFICATION_MONITOR);
#line 259 "NotificationsMonitor.c"
}


static GDBusMessage* _notification_monitor_message_filter_gd_bus_message_filter_function (GDBusConnection* connection, GDBusMessage* message, gboolean incoming, gpointer self) {
	GDBusMessage* result;
	result = notification_monitor_message_filter ((NotificationMonitor*) self, connection, message, incoming);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return result;
#line 268 "NotificationsMonitor.c"
}


static void notification_monitor_add_filter (NotificationMonitor* self) {
	GDBusMessage* message = NULL;
	GDBusMessage* _tmp0_ = NULL;
	GVariant* body = NULL;
	GVariant* _tmp1_ = NULL;
	guint32 _tmp6_ = 0U;
	GDBusConnection* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
#line 55 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_return_if_fail (self != NULL);
#line 56 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp0_ = g_dbus_message_new_method_call ("org.freedesktop.DBus", "/org/freedesktop/DBus", "org.freedesktop.DBus", "AddMatch");
#line 56 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	message = _tmp0_;
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp1_ = g_variant_new_parsed ("(%s,)", NOTIFICATION_MONITOR_MATCH_STRING, NULL);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_variant_ref_sink (_tmp1_);
#line 61 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	body = _tmp1_;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_dbus_message_set_body (message, body);
#line 294 "NotificationsMonitor.c"
	{
		INotifications* _tmp2_ = NULL;
		INotifications* _tmp3_ = NULL;
		INotifications* _tmp4_ = NULL;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp3_ = g_initable_new (TYPE_INOTIFICATIONS_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", NOTIFICATION_MONITOR_NOTIFY_IFACE, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", NOTIFICATION_MONITOR_NOTIFY_PATH, "g-interface-name", "org.freedesktop.Notifications", "g-interface-info", g_type_get_qdata (TYPE_INOTIFICATIONS, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp2_ = (INotifications*) _tmp3_;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 305 "NotificationsMonitor.c"
			goto __catch7_g_error;
		}
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp4_ = _tmp2_;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp2_ = NULL;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (self->notifications_iface);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		self->notifications_iface = _tmp4_;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (_tmp2_);
#line 318 "NotificationsMonitor.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_ = NULL;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		e = _inner_error_;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_inner_error_ = NULL;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp5_ = e->message;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_error ("NotificationsMonitor.vala:67: %s\n", _tmp5_);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_error_free0 (e);
#line 335 "NotificationsMonitor.c"
	}
	__finally7:
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_variant_unref0 (body);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (message);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_clear_error (&_inner_error_);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		return;
#line 350 "NotificationsMonitor.c"
	}
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp6_ = notification_monitor_get_current_notification_id (self);
#line 70 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self->priv->id_counter = _tmp6_;
#line 356 "NotificationsMonitor.c"
	{
		GDBusConnection* _tmp7_ = NULL;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp7_ = self->priv->connection;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_dbus_connection_send_message (_tmp7_, message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, &_inner_error_);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 365 "NotificationsMonitor.c"
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_ = NULL;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		e = _inner_error_;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp8_ = e->message;
#line 74 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_error ("NotificationsMonitor.vala:74: %s\n", _tmp8_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_error_free0 (e);
#line 384 "NotificationsMonitor.c"
	}
	__finally8:
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_variant_unref0 (body);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (message);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_clear_error (&_inner_error_);
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		return;
#line 399 "NotificationsMonitor.c"
	}
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp9_ = self->priv->connection;
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_dbus_connection_add_filter (_tmp9_, _notification_monitor_message_filter_gd_bus_message_filter_function, g_object_ref (self), g_object_unref);
#line 55 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_variant_unref0 (body);
#line 55 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_object_unref0 (message);
#line 409 "NotificationsMonitor.c"
}


static Block6Data* block6_data_ref (Block6Data* _data6_) {
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return _data6_;
#line 418 "NotificationsMonitor.c"
}


static void block6_data_unref (void * _userdata_) {
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 427 "NotificationsMonitor.c"
		NotificationMonitor* self;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		self = _data6_->self;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (_data6_->message);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_object_unref0 (self);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_slice_free (Block6Data, _data6_);
#line 437 "NotificationsMonitor.c"
	}
}


static Block7Data* block7_data_ref (Block7Data* _data7_) {
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return _data7_;
#line 447 "NotificationsMonitor.c"
}


static void block7_data_unref (void * _userdata_) {
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 456 "NotificationsMonitor.c"
		NotificationMonitor* self;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		self = _data7_->_data6_->self;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		block6_data_unref (_data7_->_data6_);
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_data7_->_data6_ = NULL;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_slice_free (Block7Data, _data7_);
#line 466 "NotificationsMonitor.c"
	}
}


static gboolean ____lambda5_ (Block7Data* _data7_) {
	Block6Data* _data6_;
	NotificationMonitor* self;
	gboolean result = FALSE;
	GDBusMessage* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_data6_ = _data7_->_data6_;
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self = _data6_->self;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp0_ = _data6_->message;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp1_ = _data7_->current_id;
#line 94 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_signal_emit_by_name (self, "received", _tmp0_, _tmp1_);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_object_unref0 (_data6_->message);
#line 95 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_data6_->message = NULL;
#line 96 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	result = FALSE;
#line 96 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return result;
#line 495 "NotificationsMonitor.c"
}


static gboolean _____lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = ____lambda5_ (self);
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return result;
#line 504 "NotificationsMonitor.c"
}


static GDBusMessage* notification_monitor_message_filter (NotificationMonitor* self, GDBusConnection* con, GDBusMessage* message, gboolean incoming) {
	GDBusMessage* result = NULL;
	Block6Data* _data6_;
	GDBusMessage* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GDBusMessage* _tmp20_ = NULL;
	GDBusMessage* _tmp21_ = NULL;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_return_val_if_fail (con != NULL, NULL);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_data6_->_ref_count_ = 1;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_data6_->self = g_object_ref (self);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp0_ = message;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_object_unref0 (_data6_->message);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_data6_->message = _tmp0_;
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp1_ = incoming;
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (_tmp1_) {
#line 537 "NotificationsMonitor.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		GDBusMessage* _tmp4_ = NULL;
		GDBusMessageType _tmp5_ = 0;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp4_ = _data6_->message;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp5_ = g_dbus_message_get_message_type (_tmp4_);
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		if (_tmp5_ == G_DBUS_MESSAGE_TYPE_METHOD_CALL) {
#line 548 "NotificationsMonitor.c"
			GDBusMessage* _tmp6_ = NULL;
			const gchar* _tmp7_ = NULL;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp6_ = _data6_->message;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp7_ = g_dbus_message_get_interface (_tmp6_);
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp3_ = g_strcmp0 (_tmp7_, NOTIFICATION_MONITOR_NOTIFY_IFACE) == 0;
#line 557 "NotificationsMonitor.c"
		} else {
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp3_ = FALSE;
#line 561 "NotificationsMonitor.c"
		}
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		if (_tmp3_) {
#line 565 "NotificationsMonitor.c"
			GDBusMessage* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
#line 84 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp8_ = _data6_->message;
#line 84 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp9_ = g_dbus_message_get_member (_tmp8_);
#line 84 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp2_ = g_strcmp0 (_tmp9_, "Notify") == 0;
#line 574 "NotificationsMonitor.c"
		} else {
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp2_ = FALSE;
#line 578 "NotificationsMonitor.c"
		}
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		if (_tmp2_) {
#line 582 "NotificationsMonitor.c"
			Block7Data* _data7_;
			guint32 replaces_id = 0U;
			GDBusMessage* _tmp10_ = NULL;
			GVariant* _tmp11_ = NULL;
			GVariant* _tmp12_ = NULL;
			GVariant* _tmp13_ = NULL;
			guint32 _tmp14_ = 0U;
			guint32 _tmp15_ = 0U;
			guint32 _tmp16_ = 0U;
			guint32 _tmp17_ = 0U;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_data7_ = g_slice_new0 (Block7Data);
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_data7_->_ref_count_ = 1;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_data7_->_data6_ = block6_data_ref (_data6_);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp10_ = _data6_->message;
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp11_ = g_dbus_message_get_body (_tmp10_);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) 1);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp13_ = _tmp12_;
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp14_ = g_variant_get_uint32 (_tmp13_);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp15_ = _tmp14_;
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_g_variant_unref0 (_tmp13_);
#line 85 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			replaces_id = _tmp15_;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp16_ = replaces_id;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_data7_->current_id = _tmp16_;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_tmp17_ = replaces_id;
#line 88 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			if (_tmp17_ == ((guint32) 0)) {
#line 623 "NotificationsMonitor.c"
				guint32 _tmp18_ = 0U;
				guint32 _tmp19_ = 0U;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
				_tmp18_ = self->priv->id_counter;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
				self->priv->id_counter = _tmp18_ + 1;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
				_tmp19_ = self->priv->id_counter;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
				_data7_->current_id = _tmp19_;
#line 634 "NotificationsMonitor.c"
			}
#line 93 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda5__gsource_func, block7_data_ref (_data7_), block7_data_unref);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			result = NULL;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			block7_data_unref (_data7_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_data7_ = NULL;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			block6_data_unref (_data6_);
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			_data6_ = NULL;
#line 99 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
			return result;
#line 650 "NotificationsMonitor.c"
		}
	}
#line 103 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp20_ = _data6_->message;
#line 103 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 103 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	result = _tmp21_;
#line 103 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	block6_data_unref (_data6_);
#line 103 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_data6_ = NULL;
#line 103 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return result;
#line 665 "NotificationsMonitor.c"
}


static void _g_free0_ (gpointer var) {
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	var = (g_free (var), NULL);
#line 672 "NotificationsMonitor.c"
}


static void _g_variant_unref0_ (gpointer var) {
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 679 "NotificationsMonitor.c"
}


static guint32 notification_monitor_get_current_notification_id (NotificationMonitor* self) {
	guint32 result = 0U;
	GHashTable* hints = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GHashTable* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GVariant* _tmp4_ = NULL;
	gchar** actions = NULL;
	gchar** _tmp5_ = NULL;
	gint actions_length1 = 0;
	gint _actions_size_ = 0;
	GError * _inner_error_ = NULL;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp0_ = g_str_hash;
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp1_ = g_str_equal;
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_variant_unref0_);
#line 108 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	hints = _tmp2_;
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp3_ = g_strdup ("suppress-sound");
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp4_ = g_variant_new_boolean (TRUE);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_variant_ref_sink (_tmp4_);
#line 109 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_hash_table_insert (hints, _tmp3_, _tmp4_);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_tmp5_ = g_new0 (gchar*, 0 + 1);
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	actions = _tmp5_;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	actions_length1 = 0;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_actions_size_ = actions_length1;
#line 722 "NotificationsMonitor.c"
	{
		guint32 _tmp6_ = 0U;
		INotifications* _tmp7_ = NULL;
		guint32 _tmp8_ = 0U;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp7_ = self->notifications_iface;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp8_ = inotifications_notify (_tmp7_, "", (guint32) 0, "", "", "", actions, actions_length1, hints, (gint32) 1, &_inner_error_);
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp6_ = _tmp8_;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 735 "NotificationsMonitor.c"
			goto __catch9_g_error;
		}
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		result = _tmp6_;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		actions = (_vala_array_free (actions, actions_length1, (GDestroyNotify) g_free), NULL);
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_hash_table_unref0 (hints);
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		return result;
#line 746 "NotificationsMonitor.c"
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp9_ = NULL;
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		e = _inner_error_;
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_tmp9_ = e->message;
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		g_error ("NotificationsMonitor.vala:114: %s\n", _tmp9_);
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		_g_error_free0 (e);
#line 763 "NotificationsMonitor.c"
	}
	__finally9:
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	actions = (_vala_array_free (actions, actions_length1, (GDestroyNotify) g_free), NULL);
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_hash_table_unref0 (hints);
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_clear_error (&_inner_error_);
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	return 0U;
#line 776 "NotificationsMonitor.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_UINT) (gpointer data1, gpointer arg_1, guint32 arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		data1 = closure->data;
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 795 "NotificationsMonitor.c"
	} else {
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
		data2 = closure->data;
#line 801 "NotificationsMonitor.c"
	}
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 807 "NotificationsMonitor.c"
}


static void notification_monitor_class_init (NotificationMonitorClass * klass) {
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	notification_monitor_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_type_class_add_private (klass, sizeof (NotificationMonitorPrivate));
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = notification_monitor_finalize;
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	g_signal_new ("received", TYPE_NOTIFICATION_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_UINT, G_TYPE_NONE, 2, g_dbus_message_get_type (), G_TYPE_UINT);
#line 820 "NotificationsMonitor.c"
}


static void notification_monitor_instance_init (NotificationMonitor * self) {
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self->priv = NOTIFICATION_MONITOR_GET_PRIVATE (self);
#line 32 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self->notifications_iface = NULL;
#line 33 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self->dbus_iface = NULL;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self->priv->id_counter = (guint32) 0;
#line 833 "NotificationsMonitor.c"
}


static void notification_monitor_finalize (GObject* obj) {
	NotificationMonitor * self;
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTIFICATION_MONITOR, NotificationMonitor);
#line 31 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_object_unref0 (self->priv->connection);
#line 32 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_object_unref0 (self->notifications_iface);
#line 33 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	_g_object_unref0 (self->dbus_iface);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Services/NotificationsMonitor.vala"
	G_OBJECT_CLASS (notification_monitor_parent_class)->finalize (obj);
#line 849 "NotificationsMonitor.c"
}


GType notification_monitor_get_type (void) {
	static volatile gsize notification_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&notification_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotificationMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationMonitor), 0, (GInstanceInitFunc) notification_monitor_instance_init, NULL };
		GType notification_monitor_type_id;
		notification_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationMonitor", &g_define_type_info, 0);
		g_once_init_leave (&notification_monitor_type_id__volatile, notification_monitor_type_id);
	}
	return notification_monitor_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



