/* NotificationEntry.c generated by valac 0.34.4, the Vala compiler
 * generated from NotificationEntry.vala, do not modify */

/*-
 * Copyright (c) 2015 Wingpanel Developers (http://launchpad.net/wingpanel)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>


#define TYPE_NOTIFICATION_ENTRY (notification_entry_get_type ())
#define NOTIFICATION_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_ENTRY, NotificationEntry))
#define NOTIFICATION_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_ENTRY, NotificationEntryClass))
#define IS_NOTIFICATION_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_ENTRY))
#define IS_NOTIFICATION_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_ENTRY))
#define NOTIFICATION_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_ENTRY, NotificationEntryClass))

typedef struct _NotificationEntry NotificationEntry;
typedef struct _NotificationEntryClass NotificationEntryClass;
typedef struct _NotificationEntryPrivate NotificationEntryPrivate;

#define TYPE_NOTIFICATION (notification_get_type ())
#define NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION, Notification))
#define NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION, NotificationClass))
#define IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION))
#define IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION))
#define NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION, NotificationClass))

typedef struct _Notification Notification;
typedef struct _NotificationClass NotificationClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _NotificationPrivate NotificationPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _NotificationEntry {
	GtkListBoxRow parent_instance;
	NotificationEntryPrivate * priv;
	Notification* notification;
	gboolean active;
};

struct _NotificationEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _NotificationEntryPrivate {
	GtkLabel* time_label;
	gchar* entry_summary;
	gchar* entry_body;
};

struct _Notification {
	GObject parent_instance;
	NotificationPrivate * priv;
	gboolean data_session;
	gchar* app_name;
	gchar* summary;
	gchar* message_body;
	gchar* app_icon;
	gchar* sender;
	gchar** actions;
	gint actions_length1;
	GVariant* hints;
	gint32 expire_timeout;
	guint32 replaces_id;
	guint32 id;
	guint32 pid;
	GDateTime* timestamp;
	gint64 unix_time;
	gchar* desktop_id;
	GAppInfo* app_info;
};

struct _NotificationClass {
	GObjectClass parent_class;
};


static gpointer notification_entry_parent_class = NULL;
static GRegex* notification_entry_entity_regex;
static GRegex* notification_entry_entity_regex = NULL;
static GRegex* notification_entry_tag_regex;
static GRegex* notification_entry_tag_regex = NULL;

GType notification_entry_get_type (void) G_GNUC_CONST;
GType notification_get_type (void) G_GNUC_CONST;
#define NOTIFICATION_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTIFICATION_ENTRY, NotificationEntryPrivate))
enum  {
	NOTIFICATION_ENTRY_DUMMY_PROPERTY
};
NotificationEntry* notification_entry_new (Notification* _notification);
NotificationEntry* notification_entry_construct (GType object_type, Notification* _notification);
static gboolean __lambda7_ (NotificationEntry* self, GTimeSpan timespan);
static gchar* notification_entry_get_string_from_timespan (NotificationEntry* self, GTimeSpan timespan);
static gboolean ___lambda7__notification_time_changed (Notification* _sender, GTimeSpan span, gpointer self);
static gchar* notification_entry_fix_markup (NotificationEntry* self, const gchar* markup);
#define CONFIG_GETTEXT_PACKAGE "notifications-indicator"
static void notification_entry_translations (NotificationEntry* self);
static void notification_entry_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 129 "NotificationEntry.c"
}


static gboolean __lambda7_ (NotificationEntry* self, GTimeSpan timespan) {
	gboolean result = FALSE;
	gchar* label = NULL;
	GTimeSpan _tmp0_ = 0LL;
	gchar* _tmp1_ = NULL;
	GtkLabel* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp0_ = timespan;
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp1_ = notification_entry_get_string_from_timespan (self, _tmp0_);
#line 50 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	label = _tmp1_;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp2_ = self->priv->time_label;
#line 51 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_label_set_label (_tmp2_, label);
#line 53 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp3_ = self->active;
#line 53 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	result = _tmp3_;
#line 53 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (label);
#line 53 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	return result;
#line 158 "NotificationEntry.c"
}


static gboolean ___lambda7__notification_time_changed (Notification* _sender, GTimeSpan span, gpointer self) {
	gboolean result;
	result = __lambda7_ ((NotificationEntry*) self, span);
#line 49 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	return result;
#line 167 "NotificationEntry.c"
}


NotificationEntry* notification_entry_construct (GType object_type, Notification* _notification) {
	NotificationEntry * self = NULL;
	Notification* _tmp0_ = NULL;
	Notification* _tmp1_ = NULL;
	Notification* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	Notification* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GtkStyleContext* _tmp8_ = NULL;
	Notification* _tmp9_ = NULL;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp10_ = NULL;
	GtkGrid* _tmp11_ = NULL;
	GtkGrid* _tmp12_ = NULL;
	GtkLabel* title_label = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	GtkLabel* _tmp20_ = NULL;
	GtkLabel* _tmp21_ = NULL;
	GtkLabel* _tmp22_ = NULL;
	GtkLabel* _tmp23_ = NULL;
	GtkLabel* _tmp24_ = NULL;
	GtkLabel* _tmp25_ = NULL;
	GtkLabel* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	GtkLabel* _tmp28_ = NULL;
	GtkGrid* _tmp29_ = NULL;
	GtkLabel* _tmp30_ = NULL;
	GtkGrid* _tmp31_ = NULL;
	GtkLabel* _tmp32_ = NULL;
	const gchar* _tmp33_ = NULL;
	GtkGrid* _tmp48_ = NULL;
	Notification* _tmp49_ = NULL;
	gboolean _tmp50_ = FALSE;
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_return_val_if_fail (_notification != NULL, NULL);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self = (NotificationEntry*) g_object_new (object_type, NULL);
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp0_ = _notification;
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_object_unref0 (self->notification);
#line 43 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self->notification = _tmp1_;
#line 44 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp2_ = self->notification;
#line 44 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp3_ = _tmp2_->summary;
#line 44 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 44 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (self->priv->entry_summary);
#line 44 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self->priv->entry_summary = _tmp4_;
#line 45 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp5_ = self->notification;
#line 45 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp6_ = _tmp5_->message_body;
#line 45 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 45 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (self->priv->entry_body);
#line 45 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self->priv->entry_body = _tmp7_;
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 47 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_style_context_add_class (_tmp8_, "menuitem");
#line 49 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp9_ = self->notification;
#line 49 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_signal_connect_object (_tmp9_, "time-changed", (GCallback) ___lambda7__notification_time_changed, self, 0);
#line 56 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 58 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp10_ = (GtkGrid*) gtk_grid_new ();
#line 58 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_object_ref_sink (_tmp10_);
#line 58 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	grid = _tmp10_;
#line 59 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp11_ = grid;
#line 59 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp11_, 40);
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp12_ = grid;
#line 60 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp12_, 6);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp13_ = self->priv->entry_summary;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp14_ = notification_entry_fix_markup (self, _tmp13_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp15_ = _tmp14_;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp16_ = g_strconcat ("<b>", _tmp15_, NULL);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp17_ = _tmp16_;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp18_ = g_strconcat (_tmp17_, "</b>", NULL);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp19_ = _tmp18_;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp20_ = (GtkLabel*) gtk_label_new (_tmp19_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_object_ref_sink (_tmp20_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp21_ = _tmp20_;
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (_tmp19_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (_tmp17_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (_tmp15_);
#line 62 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	title_label = _tmp21_;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp22_ = title_label;
#line 63 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_misc_get_type (), GtkMisc), "xalign", 0.0f, NULL);
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp23_ = title_label;
#line 64 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp23_, TRUE);
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp24_ = title_label;
#line 65 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_label_set_use_markup (_tmp24_, TRUE);
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp25_ = title_label;
#line 66 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_label_set_line_wrap (_tmp25_, TRUE);
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp26_ = title_label;
#line 67 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_object_set (_tmp26_, "wrap-mode", PANGO_WRAP_WORD, NULL);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp27_ = _ ("now");
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new (_tmp27_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_object_ref_sink (_tmp28_);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_object_unref0 (self->priv->time_label);
#line 69 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self->priv->time_label = _tmp28_;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp29_ = grid;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp30_ = title_label;
#line 71 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 0, 0, 1, 1);
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp31_ = grid;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp32_ = self->priv->time_label;
#line 72 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 1, 0, 1, 1);
#line 74 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp33_ = self->priv->entry_body;
#line 74 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	if (g_strcmp0 (_tmp33_, "") != 0) {
#line 342 "NotificationEntry.c"
		GtkLabel* body_label = NULL;
		const gchar* _tmp34_ = NULL;
		gchar* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
		GtkLabel* _tmp37_ = NULL;
		GtkLabel* _tmp38_ = NULL;
		GtkLabel* _tmp39_ = NULL;
		GtkLabel* _tmp40_ = NULL;
		GtkLabel* _tmp41_ = NULL;
		GtkLabel* _tmp42_ = NULL;
		GtkLabel* _tmp43_ = NULL;
		GtkLabel* _tmp44_ = NULL;
		GtkLabel* _tmp45_ = NULL;
		GtkGrid* _tmp46_ = NULL;
		GtkLabel* _tmp47_ = NULL;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp34_ = self->priv->entry_body;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp35_ = notification_entry_fix_markup (self, _tmp34_);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp36_ = _tmp35_;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp37_ = (GtkLabel*) gtk_label_new (_tmp36_);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_object_ref_sink (_tmp37_);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp38_ = _tmp37_;
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_free0 (_tmp36_);
#line 75 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		body_label = _tmp38_;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp39_ = body_label;
#line 76 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_misc_get_type (), GtkMisc), "xalign", 0.0f, NULL);
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp40_ = body_label;
#line 77 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp40_, 6);
#line 78 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp41_ = body_label;
#line 78 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp41_, 3);
#line 79 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp42_ = body_label;
#line 79 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		gtk_label_set_use_markup (_tmp42_, TRUE);
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp43_ = body_label;
#line 80 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		gtk_label_set_line_wrap (_tmp43_, TRUE);
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp44_ = body_label;
#line 81 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_object_set (_tmp44_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp45_ = body_label;
#line 82 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		gtk_label_set_max_width_chars (_tmp45_, 32);
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp46_ = grid;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp47_ = body_label;
#line 83 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, 0, 1, 2, 1);
#line 74 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_object_unref0 (body_label);
#line 410 "NotificationEntry.c"
	}
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp48_ = grid;
#line 86 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp48_);
#line 87 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp49_ = self->notification;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp50_ = _tmp49_->data_session;
#line 89 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	if (_tmp50_) {
#line 424 "NotificationEntry.c"
		Notification* _tmp51_ = NULL;
		Notification* _tmp52_ = NULL;
		GDateTime* _tmp53_ = NULL;
		GDateTime* _tmp54_ = NULL;
		GDateTime* _tmp55_ = NULL;
		GTimeSpan _tmp56_ = 0LL;
		gboolean _tmp57_ = FALSE;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp51_ = self->notification;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp52_ = self->notification;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp53_ = _tmp52_->timestamp;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp54_ = g_date_time_new_now_local ();
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp55_ = _tmp54_;
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp56_ = g_date_time_difference (_tmp53_, _tmp55_);
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_signal_emit_by_name (_tmp51_, "time-changed", _tmp56_, &_tmp57_);
#line 90 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_date_time_unref0 (_tmp55_);
#line 448 "NotificationEntry.c"
	}
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_object_unref0 (title_label);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_object_unref0 (grid);
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	return self;
#line 456 "NotificationEntry.c"
}


NotificationEntry* notification_entry_new (Notification* _notification) {
#line 42 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	return notification_entry_construct (TYPE_NOTIFICATION_ENTRY, _notification);
#line 463 "NotificationEntry.c"
}


/**
     * Copied from gnome-shell, fixes the mess of markup that is sent to us
     */
static gchar* notification_entry_fix_markup (NotificationEntry* self, const gchar* markup) {
	gchar* result = NULL;
	gchar* text = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 97 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 98 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp0_ = markup;
#line 98 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 98 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	text = _tmp1_;
#line 486 "NotificationEntry.c"
	{
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GRegex* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp3_ = notification_entry_entity_regex;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp4_ = markup;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp5_ = markup;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp6_ = strlen (_tmp5_);
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp7_ = _tmp6_;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp8_ = g_regex_replace (_tmp3_, _tmp4_, (gssize) _tmp7_, 0, "&amp;", 0, &_inner_error_);
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp2_ = _tmp8_;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 520 "NotificationEntry.c"
			goto __catch4_g_error;
		}
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp9_ = _tmp2_;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp2_ = NULL;
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_free0 (text);
#line 101 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		text = _tmp9_;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp11_ = notification_entry_tag_regex;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp12_ = text;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp13_ = text;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp14_ = strlen (_tmp13_);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp15_ = _tmp14_;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp16_ = g_regex_replace (_tmp11_, _tmp12_, (gssize) _tmp15_, 0, "&lt;", 0, &_inner_error_);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp10_ = _tmp16_;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_g_free0 (_tmp2_);
#line 549 "NotificationEntry.c"
			goto __catch4_g_error;
		}
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp17_ = _tmp10_;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp10_ = NULL;
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_free0 (text);
#line 102 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		text = _tmp17_;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_free0 (_tmp10_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_free0 (_tmp2_);
#line 564 "NotificationEntry.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		e = _inner_error_;
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_inner_error_ = NULL;
#line 104 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp18_ = e;
#line 104 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp19_ = _tmp18_->message;
#line 104 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_warning ("NotificationEntry.vala:104: Invalid regex: %s", _tmp19_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_error_free0 (e);
#line 584 "NotificationEntry.c"
	}
	__finally4:
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_free0 (text);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_clear_error (&_inner_error_);
#line 100 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		return NULL;
#line 597 "NotificationEntry.c"
	}
#line 107 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	result = text;
#line 107 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	return result;
#line 603 "NotificationEntry.c"
}


static gchar* notification_entry_get_string_from_timespan (NotificationEntry* self, GTimeSpan timespan) {
	gchar* result = NULL;
	GTimeSpan _tmp0_ = 0LL;
#line 110 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_tmp0_ = timespan;
#line 111 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	if ((-_tmp0_) >= G_TIME_SPAN_DAY) {
#line 616 "NotificationEntry.c"
		gulong days = 0UL;
		GTimeSpan _tmp1_ = 0LL;
		gulong _tmp2_ = 0UL;
		const gchar* _tmp3_ = NULL;
		gulong _tmp4_ = 0UL;
		gchar* _tmp5_ = NULL;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp1_ = timespan;
#line 112 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		days = (gulong) ((-_tmp1_) / G_TIME_SPAN_DAY);
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp2_ = days;
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp3_ = g_dngettext (CONFIG_GETTEXT_PACKAGE, "%ld day", "%ld days", _tmp2_);
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp4_ = days;
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp5_ = g_strdup_printf (_tmp3_, _tmp4_);
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		result = _tmp5_;
#line 113 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		return result;
#line 639 "NotificationEntry.c"
	} else {
		GTimeSpan _tmp6_ = 0LL;
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp6_ = timespan;
#line 114 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		if ((-_tmp6_) >= G_TIME_SPAN_HOUR) {
#line 646 "NotificationEntry.c"
			gulong hours = 0UL;
			GTimeSpan _tmp7_ = 0LL;
			gulong _tmp8_ = 0UL;
			const gchar* _tmp9_ = NULL;
			gulong _tmp10_ = 0UL;
			gchar* _tmp11_ = NULL;
#line 115 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_tmp7_ = timespan;
#line 115 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			hours = (gulong) ((-_tmp7_) / G_TIME_SPAN_HOUR);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_tmp8_ = hours;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_tmp9_ = g_dngettext (CONFIG_GETTEXT_PACKAGE, "%ld hour", "%ld hours", _tmp8_);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_tmp10_ = hours;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_tmp11_ = g_strdup_printf (_tmp9_, _tmp10_);
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			result = _tmp11_;
#line 116 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			return result;
#line 669 "NotificationEntry.c"
		} else {
			GTimeSpan _tmp12_ = 0LL;
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_tmp12_ = timespan;
#line 117 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			if ((-_tmp12_) >= G_TIME_SPAN_MINUTE) {
#line 676 "NotificationEntry.c"
				gulong minutes = 0UL;
				GTimeSpan _tmp13_ = 0LL;
				gulong _tmp14_ = 0UL;
				const gchar* _tmp15_ = NULL;
				gulong _tmp16_ = 0UL;
				gchar* _tmp17_ = NULL;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				_tmp13_ = timespan;
#line 118 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				minutes = (gulong) ((-_tmp13_) / G_TIME_SPAN_MINUTE);
#line 119 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				_tmp14_ = minutes;
#line 119 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				_tmp15_ = g_dngettext (CONFIG_GETTEXT_PACKAGE, "%ld minute", "%ld minutes", _tmp14_);
#line 119 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				_tmp16_ = minutes;
#line 119 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				_tmp17_ = g_strdup_printf (_tmp15_, _tmp16_);
#line 119 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				result = _tmp17_;
#line 119 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				return result;
#line 699 "NotificationEntry.c"
			} else {
				const gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				_tmp18_ = _ ("Now");
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				_tmp19_ = g_strdup (_tmp18_);
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				result = _tmp19_;
#line 121 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
				return result;
#line 711 "NotificationEntry.c"
			}
		}
	}
}


static void notification_entry_translations (NotificationEntry* self) {
#line 126 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_return_if_fail (self != NULL);
#line 127 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	ngettext ("%ld day", "%ld days", (gulong) 0);
#line 128 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	ngettext ("%ld hour", "%ld hours", (gulong) 0);
#line 129 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	ngettext ("%ld minute", "%ld minutes", (gulong) 0);
#line 727 "NotificationEntry.c"
}


static void notification_entry_class_init (NotificationEntryClass * klass) {
	GError * _inner_error_ = NULL;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	notification_entry_parent_class = g_type_class_peek_parent (klass);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_type_class_add_private (klass, sizeof (NotificationEntryPrivate));
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = notification_entry_finalize;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	g_signal_new ("clear", TYPE_NOTIFICATION_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 741 "NotificationEntry.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		GRegex* _tmp5_ = NULL;
#line 35 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp1_ = g_regex_new ("&(?!amp;|quot;|apos;|lt;|gt;)", 0, 0, &_inner_error_);
#line 35 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp0_ = _tmp1_;
#line 35 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 755 "NotificationEntry.c"
			goto __catch5_g_error;
		}
#line 35 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp2_ = _tmp0_;
#line 35 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp0_ = NULL;
#line 35 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_regex_unref0 (notification_entry_entity_regex);
#line 35 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		notification_entry_entity_regex = _tmp2_;
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp4_ = g_regex_new ("<(?!\\/?[biu]>)", 0, 0, &_inner_error_);
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp3_ = _tmp4_;
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
			_g_regex_unref0 (_tmp0_);
#line 774 "NotificationEntry.c"
			goto __catch5_g_error;
		}
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp5_ = _tmp3_;
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp3_ = NULL;
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_regex_unref0 (notification_entry_tag_regex);
#line 36 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		notification_entry_tag_regex = _tmp5_;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_regex_unref0 (_tmp3_);
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_regex_unref0 (_tmp0_);
#line 789 "NotificationEntry.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		e = _inner_error_;
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_inner_error_ = NULL;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp6_ = e;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_tmp7_ = _tmp6_->message;
#line 38 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_warning ("NotificationEntry.vala:38: Invalid regex: %s", _tmp7_);
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		_g_error_free0 (e);
#line 809 "NotificationEntry.c"
	}
	__finally5:
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 34 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
		g_clear_error (&_inner_error_);
#line 818 "NotificationEntry.c"
	}
}


static void notification_entry_instance_init (NotificationEntry * self) {
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self->priv = NOTIFICATION_ENTRY_GET_PRIVATE (self);
#line 28 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self->active = TRUE;
#line 828 "NotificationEntry.c"
}


static void notification_entry_finalize (GObject* obj) {
	NotificationEntry * self;
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTIFICATION_ENTRY, NotificationEntry);
#line 21 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_object_unref0 (self->notification);
#line 23 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_object_unref0 (self->priv->time_label);
#line 25 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (self->priv->entry_summary);
#line 26 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	_g_free0 (self->priv->entry_body);
#line 18 "/builddir/build/BUILD/wingpanel-indicator-notifications-2.0/src/Widgets/NotificationEntry.vala"
	G_OBJECT_CLASS (notification_entry_parent_class)->finalize (obj);
#line 846 "NotificationEntry.c"
}


GType notification_entry_get_type (void) {
	static volatile gsize notification_entry_type_id__volatile = 0;
	if (g_once_init_enter (&notification_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotificationEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationEntry), 0, (GInstanceInitFunc) notification_entry_instance_init, NULL };
		GType notification_entry_type_id;
		notification_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NotificationEntry", &g_define_type_info, 0);
		g_once_init_leave (&notification_entry_type_id__volatile, notification_entry_type_id);
	}
	return notification_entry_type_id__volatile;
}



